/* number-picker.c generated by valac 0.41.91, the Vala compiler
 * generated from number-picker.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _NumberPickerPrivate NumberPickerPrivate;
enum  {
	NUMBER_PICKER_0_PROPERTY,
	NUMBER_PICKER_NUM_PROPERTIES
};
static GParamSpec* number_picker_properties[NUMBER_PICKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block5Data Block5Data;
enum  {
	NUMBER_PICKER_NUMBER_PICKED_SIGNAL,
	NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL,
	NUMBER_PICKER_NUM_SIGNALS
};
static guint number_picker_signals[NUMBER_PICKER_NUM_SIGNALS] = {0};

struct _NumberPicker {
	GtkGrid parent_instance;
	NumberPickerPrivate * priv;
};

struct _NumberPickerClass {
	GtkGridClass parent_class;
};

struct _NumberPickerPrivate {
	SudokuBoard* board;
	GtkButton* clear_button;
	gint earmarks_active;
};

struct _Block4Data {
	int _ref_count_;
	NumberPicker* self;
	gint n;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GtkToggleButton* toggle_button;
};


static gint NumberPicker_private_offset;
static gpointer number_picker_parent_class = NULL;

GType number_picker_get_type (void) G_GNUC_CONST;
#define NUMBER_PICKER_EARMARKS_MAX_ALLOWED 5
NumberPicker* number_picker_new (SudokuBoard* * board,
                                 gboolean earmark);
NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard* * board,
                                       gboolean earmark);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _________lambda4_ (Block4Data* _data4_);
static void __________lambda4__gtk_button_clicked (GtkButton* _sender,
                                            gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _________lambda5_ (Block5Data* _data5_);
static void number_picker_set_toggle_sensitive (NumberPicker* self,
                                         gboolean state);
static void __________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                   gpointer self);
static void ___lambda6_ (NumberPicker* self);
static void ____lambda6__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
gboolean number_picker_set_earmark (NumberPicker* self,
                                    gint row,
                                    gint col,
                                    gint index,
                                    gboolean state);
static void g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void number_picker_finalize (GObject * obj);


static inline gpointer
number_picker_get_instance_private (NumberPicker* self)
{
	return G_STRUCT_MEMBER_P (self, NumberPicker_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		NumberPicker* self;
		self = _data4_->self;
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}


static void
_________lambda4_ (Block4Data* _data4_)
{
	NumberPicker* self;
	gint _tmp0_;
	self = _data4_->self;
	_tmp0_ = _data4_->n;
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL], 0, _tmp0_);
}


static void
__________lambda4__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self)
{
	_________lambda4_ (self);
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		NumberPicker* self;
		self = _data5_->_data4_->self;
		_g_object_unref0 (_data5_->toggle_button);
		block4_data_unref (_data5_->_data4_);
		_data5_->_data4_ = NULL;
		g_slice_free (Block5Data, _data5_);
	}
}


static void
_________lambda5_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	NumberPicker* self;
	gboolean toggle_active = FALSE;
	GtkToggleButton* _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	gint _tmp7_;
	_data4_ = _data5_->_data4_;
	self = _data4_->self;
	_tmp0_ = _data5_->toggle_button;
	toggle_active = gtk_toggle_button_get_active (_tmp0_);
	_tmp1_ = _data4_->n;
	_tmp2_ = toggle_active;
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL], 0, _tmp1_, _tmp2_);
	_tmp4_ = toggle_active;
	if (_tmp4_) {
		gint _tmp5_;
		_tmp5_ = self->priv->earmarks_active;
		_tmp3_ = _tmp5_ + 1;
	} else {
		gint _tmp6_;
		_tmp6_ = self->priv->earmarks_active;
		_tmp3_ = _tmp6_ - 1;
	}
	self->priv->earmarks_active = _tmp3_;
	_tmp7_ = self->priv->earmarks_active;
	if (_tmp7_ < NUMBER_PICKER_EARMARKS_MAX_ALLOWED) {
		number_picker_set_toggle_sensitive (self, TRUE);
	} else {
		number_picker_set_toggle_sensitive (self, FALSE);
	}
}


static void
__________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self)
{
	_________lambda5_ (self);
}


static void
___lambda6_ (NumberPicker* self)
{
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL], 0, 0);
}


static void
____lambda6__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	___lambda6_ ((NumberPicker*) self);
}


NumberPicker*
number_picker_construct (GType object_type,
                         SudokuBoard* * board,
                         gboolean earmark)
{
	NumberPicker * self = NULL;
	SudokuBoard* _tmp0_;
	g_return_val_if_fail (*board != NULL, NULL);
	self = (NumberPicker*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (*board);
	_g_object_unref0 (self->priv->board);
	self->priv->board = _tmp0_;
	self->priv->earmarks_active = 0;
	{
		gint col = 0;
		col = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = col;
					col = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = col;
				_tmp4_ = sudoku_board_get_block_cols (*board);
				_tmp5_ = _tmp4_;
				if (!(_tmp3_ < _tmp5_)) {
					break;
				}
				{
					gint row = 0;
					row = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							Block4Data* _data4_;
							gint _tmp8_;
							gint _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							gint _tmp14_;
							GtkButton* _tmp15_ = NULL;
							GtkButton* button = NULL;
							GtkButton* _tmp18_;
							GtkButton* _tmp19_;
							GtkButton* _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							GtkLabel* label = NULL;
							gint _tmp23_;
							gchar* _tmp24_;
							gchar* _tmp25_;
							GtkLabel* _tmp26_;
							GtkLabel* _tmp27_;
							GtkLabel* _tmp28_;
							GtkLabel* _tmp29_;
							GtkLabel* _tmp30_;
							GtkLabel* _tmp31_;
							GtkButton* _tmp32_;
							GtkLabel* _tmp33_;
							GtkLabel* _tmp34_;
							gint _tmp39_;
							GtkButton* _tmp41_;
							_data4_ = g_slice_new0 (Block4Data);
							_data4_->_ref_count_ = 1;
							_data4_->self = g_object_ref (self);
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = row;
								row = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = row;
							_tmp9_ = sudoku_board_get_block_rows (*board);
							_tmp10_ = _tmp9_;
							if (!(_tmp8_ < _tmp10_)) {
								block4_data_unref (_data4_);
								_data4_ = NULL;
								break;
							}
							_tmp11_ = col;
							_tmp12_ = row;
							_tmp13_ = sudoku_board_get_block_cols (*board);
							_tmp14_ = _tmp13_;
							_data4_->n = (_tmp11_ + (_tmp12_ * _tmp14_)) + 1;
							if (earmark) {
								GtkToggleButton* _tmp16_;
								_tmp16_ = (GtkToggleButton*) gtk_toggle_button_new ();
								_g_object_unref0 (_tmp15_);
								_tmp15_ = (GtkButton*) _tmp16_;
							} else {
								GtkButton* _tmp17_;
								_tmp17_ = (GtkButton*) gtk_button_new ();
								_g_object_unref0 (_tmp15_);
								_tmp15_ = _tmp17_;
							}
							_tmp18_ = _g_object_ref0 (_tmp15_);
							button = _tmp18_;
							_tmp19_ = button;
							gtk_widget_set_focus_on_click ((GtkWidget*) _tmp19_, FALSE);
							_tmp20_ = button;
							_tmp21_ = col;
							_tmp22_ = row;
							gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp20_, _tmp21_, _tmp22_, 1, 1);
							_tmp23_ = _data4_->n;
							_tmp24_ = g_strdup_printf ("<big>%d</big>", _tmp23_);
							_tmp25_ = _tmp24_;
							_tmp26_ = (GtkLabel*) gtk_label_new (_tmp25_);
							g_object_ref_sink (_tmp26_);
							_tmp27_ = _tmp26_;
							_g_free0 (_tmp25_);
							label = _tmp27_;
							_tmp28_ = label;
							gtk_label_set_use_markup (_tmp28_, TRUE);
							_tmp29_ = label;
							g_object_set ((GtkWidget*) _tmp29_, "margin", 4, NULL);
							_tmp30_ = label;
							gtk_widget_set_margin_start ((GtkWidget*) _tmp30_, 8);
							_tmp31_ = label;
							gtk_widget_set_margin_end ((GtkWidget*) _tmp31_, 8);
							_tmp32_ = button;
							_tmp33_ = label;
							gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
							_tmp34_ = label;
							gtk_widget_show ((GtkWidget*) _tmp34_);
							if (!earmark) {
								GtkButton* _tmp35_;
								_tmp35_ = button;
								g_signal_connect_data (_tmp35_, "clicked", (GCallback) __________lambda4__gtk_button_clicked, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
							} else {
								Block5Data* _data5_;
								GtkButton* _tmp36_;
								GtkToggleButton* _tmp37_;
								GtkToggleButton* _tmp38_;
								_data5_ = g_slice_new0 (Block5Data);
								_data5_->_ref_count_ = 1;
								_data5_->_data4_ = block4_data_ref (_data4_);
								_tmp36_ = button;
								_tmp37_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_toggle_button_get_type (), GtkToggleButton));
								_data5_->toggle_button = _tmp37_;
								_tmp38_ = _data5_->toggle_button;
								g_signal_connect_data (_tmp38_, "toggled", (GCallback) __________lambda5__gtk_toggle_button_toggled, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
								block5_data_unref (_data5_);
								_data5_ = NULL;
							}
							_tmp39_ = _data4_->n;
							if (_tmp39_ == 5) {
								GtkButton* _tmp40_;
								_tmp40_ = button;
								gtk_widget_grab_focus ((GtkWidget*) _tmp40_);
							}
							_tmp41_ = button;
							gtk_widget_show ((GtkWidget*) _tmp41_);
							_g_object_unref0 (label);
							_g_object_unref0 (button);
							_g_object_unref0 (_tmp15_);
							block4_data_unref (_data4_);
							_data4_ = NULL;
						}
					}
				}
			}
		}
	}
	if (!earmark) {
		GtkButton* _tmp42_;
		GtkButton* _tmp43_;
		GtkButton* _tmp44_;
		GtkLabel* label = NULL;
		gchar* _tmp45_;
		gchar* _tmp46_;
		GtkLabel* _tmp47_;
		GtkLabel* _tmp48_;
		GtkLabel* _tmp49_;
		GtkButton* _tmp50_;
		GtkLabel* _tmp51_;
		GtkLabel* _tmp52_;
		GtkButton* _tmp53_;
		_tmp42_ = (GtkButton*) gtk_button_new ();
		g_object_ref_sink (_tmp42_);
		_g_object_unref0 (self->priv->clear_button);
		self->priv->clear_button = _tmp42_;
		_tmp43_ = self->priv->clear_button;
		gtk_widget_set_focus_on_click ((GtkWidget*) _tmp43_, FALSE);
		_tmp44_ = self->priv->clear_button;
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp44_, 0, 4, 3, 1);
		_tmp45_ = g_strdup_printf ("<big>%s</big>", _ ("Clear"));
		_tmp46_ = _tmp45_;
		_tmp47_ = (GtkLabel*) gtk_label_new (_tmp46_);
		g_object_ref_sink (_tmp47_);
		_tmp48_ = _tmp47_;
		_g_free0 (_tmp46_);
		label = _tmp48_;
		_tmp49_ = label;
		gtk_label_set_use_markup (_tmp49_, TRUE);
		_tmp50_ = self->priv->clear_button;
		_tmp51_ = label;
		gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
		_tmp52_ = label;
		gtk_widget_show ((GtkWidget*) _tmp52_);
		_tmp53_ = self->priv->clear_button;
		g_signal_connect_object (_tmp53_, "clicked", (GCallback) ____lambda6__gtk_button_clicked, self, 0);
		_g_object_unref0 (label);
	}
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	g_object_set ((GtkWidget*) self, "margin", 2, NULL);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 3);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 3);
	gtk_widget_show ((GtkWidget*) self);
	return self;
}


NumberPicker*
number_picker_new (SudokuBoard* * board,
                   gboolean earmark)
{
	return number_picker_construct (TYPE_NUMBER_PICKER, board, earmark);
}


void
number_picker_set_clear_button_visibility (NumberPicker* self,
                                           gboolean visible)
{
	g_return_if_fail (self != NULL);
	if (visible) {
		GtkButton* _tmp0_;
		_tmp0_ = self->priv->clear_button;
		gtk_widget_show ((GtkWidget*) _tmp0_);
	} else {
		GtkButton* _tmp1_;
		_tmp1_ = self->priv->clear_button;
		gtk_widget_hide ((GtkWidget*) _tmp1_);
	}
}


void
number_picker_set_earmarks (NumberPicker* self,
                            gint row,
                            gint col)
{
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				SudokuBoard* _tmp7_;
				gint _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->board;
				_tmp4_ = sudoku_board_get_max_val (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = i;
				_tmp7_ = self->priv->board;
				_tmp8_ = i;
				number_picker_set_earmark (self, row, col, _tmp6_, sudoku_board_is_earmark_enabled (_tmp7_, row, col, _tmp8_ + 1));
			}
		}
	}
}


gboolean
number_picker_set_earmark (NumberPicker* self,
                           gint row,
                           gint col,
                           gint index,
                           gboolean state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkToggleButton* button = NULL;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	SudokuBoard* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkWidget* _tmp8_;
	GtkToggleButton* _tmp9_;
	GtkToggleButton* _tmp10_;
	g_return_val_if_fail (self != NULL, FALSE);
	if (state) {
		gint _tmp1_;
		_tmp1_ = self->priv->earmarks_active;
		_tmp0_ = _tmp1_ >= NUMBER_PICKER_EARMARKS_MAX_ALLOWED;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->board;
	_tmp3_ = sudoku_board_get_block_cols (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = self->priv->board;
	_tmp6_ = sudoku_board_get_block_rows (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = gtk_grid_get_child_at ((GtkGrid*) self, index % _tmp4_, index / _tmp7_);
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_toggle_button_get_type (), GtkToggleButton));
	button = _tmp9_;
	_tmp10_ = button;
	gtk_toggle_button_set_active (_tmp10_, state);
	result = TRUE;
	_g_object_unref0 (button);
	return result;
}


static void
number_picker_set_toggle_sensitive (NumberPicker* self,
                                    gboolean state)
{
	g_return_if_fail (self != NULL);
	if (state) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp0_ = FALSE;
				_tmp0_ = TRUE;
				while (TRUE) {
					gint _tmp2_;
					SudokuBoard* _tmp3_;
					gint _tmp4_;
					gint _tmp5_;
					gint _tmp6_;
					SudokuBoard* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					SudokuBoard* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
					GtkWidget* _tmp14_;
					if (!_tmp0_) {
						gint _tmp1_;
						_tmp1_ = i;
						i = _tmp1_ + 1;
					}
					_tmp0_ = FALSE;
					_tmp2_ = i;
					_tmp3_ = self->priv->board;
					_tmp4_ = sudoku_board_get_max_val (_tmp3_);
					_tmp5_ = _tmp4_;
					if (!(_tmp2_ < _tmp5_)) {
						break;
					}
					_tmp6_ = i;
					_tmp7_ = self->priv->board;
					_tmp8_ = sudoku_board_get_block_cols (_tmp7_);
					_tmp9_ = _tmp8_;
					_tmp10_ = i;
					_tmp11_ = self->priv->board;
					_tmp12_ = sudoku_board_get_block_rows (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = gtk_grid_get_child_at ((GtkGrid*) self, _tmp6_ % _tmp9_, _tmp10_ / _tmp13_);
					gtk_widget_set_sensitive (_tmp14_, TRUE);
				}
			}
		}
	} else {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp15_ = FALSE;
				_tmp15_ = TRUE;
				while (TRUE) {
					gint _tmp17_;
					SudokuBoard* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					GtkToggleButton* button = NULL;
					gint _tmp21_;
					SudokuBoard* _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					SudokuBoard* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					GtkWidget* _tmp29_;
					GtkToggleButton* _tmp30_;
					GtkToggleButton* _tmp31_;
					gboolean _tmp32_;
					gboolean _tmp33_;
					if (!_tmp15_) {
						gint _tmp16_;
						_tmp16_ = i;
						i = _tmp16_ + 1;
					}
					_tmp15_ = FALSE;
					_tmp17_ = i;
					_tmp18_ = self->priv->board;
					_tmp19_ = sudoku_board_get_max_val (_tmp18_);
					_tmp20_ = _tmp19_;
					if (!(_tmp17_ < _tmp20_)) {
						break;
					}
					_tmp21_ = i;
					_tmp22_ = self->priv->board;
					_tmp23_ = sudoku_board_get_block_cols (_tmp22_);
					_tmp24_ = _tmp23_;
					_tmp25_ = i;
					_tmp26_ = self->priv->board;
					_tmp27_ = sudoku_board_get_block_rows (_tmp26_);
					_tmp28_ = _tmp27_;
					_tmp29_ = gtk_grid_get_child_at ((GtkGrid*) self, _tmp21_ % _tmp24_, _tmp25_ / _tmp28_);
					_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_toggle_button_get_type (), GtkToggleButton));
					button = _tmp30_;
					_tmp31_ = button;
					_tmp32_ = gtk_toggle_button_get_active (_tmp31_);
					_tmp33_ = _tmp32_;
					if (!_tmp33_) {
						GtkToggleButton* _tmp34_;
						_tmp34_ = button;
						gtk_widget_set_sensitive ((GtkWidget*) _tmp34_, FALSE);
					}
					_g_object_unref0 (button);
				}
			}
		}
	}
}


static void
g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_BOOLEAN) (gpointer data1, gint arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}


static void
number_picker_class_init (NumberPickerClass * klass)
{
	number_picker_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NumberPicker_private_offset);
	G_OBJECT_CLASS (klass)->finalize = number_picker_finalize;
	number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL] = g_signal_new ("number-picked", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL] = g_signal_new ("earmark-state-changed", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_BOOLEAN);
}


static void
number_picker_instance_init (NumberPicker * self)
{
	self->priv = number_picker_get_instance_private (self);
}


static void
number_picker_finalize (GObject * obj)
{
	NumberPicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER_PICKER, NumberPicker);
	_g_object_unref0 (self->priv->board);
	_g_object_unref0 (self->priv->clear_button);
	G_OBJECT_CLASS (number_picker_parent_class)->finalize (obj);
}


GType
number_picker_get_type (void)
{
	static volatile gsize number_picker_type_id__volatile = 0;
	if (g_once_init_enter (&number_picker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NumberPickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NumberPicker), 0, (GInstanceInitFunc) number_picker_instance_init, NULL };
		GType number_picker_type_id;
		number_picker_type_id = g_type_register_static (gtk_grid_get_type (), "NumberPicker", &g_define_type_info, 0);
		NumberPicker_private_offset = g_type_add_instance_private (number_picker_type_id, sizeof (NumberPickerPrivate));
		g_once_init_leave (&number_picker_type_id__volatile, number_picker_type_id);
	}
	return number_picker_type_id__volatile;
}



